<template>
	<div>
		<div class="q-pa-md row items-start q-gutter-md">
			<q-card class="my-card absolute-center">
				<q-card-section>
					<q-input
						outlined
						v-model="username"
						label="Username"
						:rules="[(val) => !!val || 'Field is required']"
						ref="username"
					/>
					<q-input
						type="password"
						outlined
						v-model="password"
						label="Password"
						:rules="[(val) => !!val || 'Field is required']"
						ref="password"
					/>
					<q-btn
						style="width: 100%;"
						color="primary"
						label="Login"
						size="lg"
						@click="login"
					/>
				</q-card-section>
			</q-card>
			<q-dialog
				v-model="alertSuccess"
				persistent
				transition-show="scale"
				transition-hide="scale"
			>
				<q-card
					class="text-white"
					style="width: 300px;"
					:style="{ background: color }"
				>
					<q-card-section>
						<div class="text-h6">{{ title }}</div>
					</q-card-section>

					<q-card-section class="q-pt-none">
						{{ message }}
					</q-card-section>

					<q-card-actions align="right" class="bg-white text-teal">
						<q-btn flat label="OK" v-close-popup @click="ok" />
					</q-card-actions>
				</q-card>
			</q-dialog>
		</div>
	</div>
</template>

<script>
import { mapActions } from "vuex";
export default {
	data() {
		return {
			alertSuccess: false,
			title: null,
			color: null,
			message: null,
			username: null,
			password: null,
			redirect: false,
		};
	},
	methods: {
		...mapActions({
			userManagementPriv: "showcase/userManagementPriv",
			userInformationPriv: "showcase/userInformationPriv",
			todoPriv: "showcase/todoPriv",
			setUserId: "showcase/userId",
			setUserLevel: "showcase/userLevel",
		}),

		login() {
			this.$refs.username.validate();
			this.$refs.password.validate();

			if (
				!this.$refs.username.hasError &&
				!this.$refs.password.hasError
			) {
				this.$axios
					.post(
						this.host + "/src/php/actions/login.php",
						{
							username: this.username,
							password: this.password,
						},
						{ withCredentials: true }
					)
					.then((response) => {
						if (response.data.error) {
							this.title = response.data.title;
							this.message = response.data.message;
							this.color = "red";
							this.redirect = false;
						} else {
							this.title = response.data.title;
							this.message = response.data.message;
							this.color = "green";
							this.redirect = true;
							this.setUserId(response.data.userId);
							this.setUserLevel(response.data.userLevel);
							this.userManagementPriv({
								umAccess: response.data.umAccess,
								umModify: response.data.umModify,
							});
							this.userInformationPriv({
								uiAccess: response.data.uiAccess,
								uiAdd: response.data.uiAdd,
								uiEdit: response.data.uiEdit,
								uiDelete: response.data.uiDelete,
							});
							this.todoPriv({
								tdAccess: response.data.tdAccess,
								tdAdd: response.data.tdAdd,
								tdEdit: response.data.tdEdit,
								tdDelete: response.data.tdDelete,
							});
						}
					});
				this.alertSuccess = true;
			}
		},
		ok() {
			if (this.redirect) {
				this.$router.push({ path: "/home" });
			}
		},
	},
};
</script>

<style>
.my-card {
	margin: auto;
	width: 80% !important;
}
@media only screen and (min-width: 768px) {
	.my-card {
		width: 400px !important;
	}
}
</style>
